# frozen_string_literal: true
module Hyrax
  module Workflow
    class ArchiveNotification < AbstractNotification
      private

      def subject
        I18n.t('hyrax.notifications.workflow.archived.subject')
      end

      def message
        I18n.t('hyrax.notifications.workflow.archived.message',
                title: title,
                link: (link_to work_id, document_path),
                user: user.user_key,
                comment: comment)
      end

      def users_to_notify
        collection = @entity.proxy_for.parent_collections.first

        [::User.find_by(email: document.depositor)]
      end
    end
  end
end
