# frozen_string_literal: true

module Hyrax
  module Workflow
    module ChangesRequired
      class CrcManagerNotification < AbstractNotification
        private

        def subject
          I18n.t('hyrax.notifications.workflow.changes_required.subject')
        end

        def message
          I18n.t('hyrax.notifications.workflow.changes_required.message',
                title: title,
                link: (link_to work_id, document_path),
                comment: comment)
        end

        def users_to_notify
          collection = @entity.proxy_for.parent_collections.first

          [::User.find_by(email: document.depositor)] + ::User.includes(:roles).where(roles: { name: "#{collection.collection_type.title.parameterize(separator: '_')}_#{collection.id}_manager", is_crc_group_manager: true }).to_a
        end
      end
    end
  end
end
