require 'rails_helper'

RSpec.describe ComplexSubject do
  before do
    ActiveFedora::Cleaner.clean!
  end
  it 'creates a complex subject with its attributes' do
    admin_role = Role.find_by(name: "admin")
    user = admin_role.users.first
    crc_dataset = create(:crc_dataset)

    
    complex_subject = build(:complex_subject, :subject_title, :subject_species, :subject_type, crc_dataset_id: crc_dataset.id)

    expect(complex_subject.crc_dataset.id).to eq(crc_dataset.id)
  end
end